src/main/java/com/epam/libraryProject/repository/entity/Entity.java
package com.epam.libraryProject.repository.entity;

public class Entity<T> {
    private T id;

    public Entity() {
    }
    public Entity(T id) {
        this.id = id;
    }

    public T getId() {
        return id;
    }

    public void setId(T id) {
        this.id = id;
    }

    @Override
    public String toString() {
        return "Entity{" + "id=" + id + '}';
    }
}

src/main/java/com/epam/libraryProject/repository/entity/book/Book.java
package com.epam.libraryProject.repository.entity.book;

import com.epam.libraryProject.repository.entity.Entity;

import java.util.Objects;

public class Book extends Entity<Integer> {

    private Genre genre;

    private String author;
    private String name;
    private String publishingHouse;
    private int yearPublishing;
    private int numberOfPage;
    private int quantity;

    public Book() {
    }
    public Book(Integer id) {
        super(id);
    }

    public Genre getGenre() {
        return genre;
    }

    public void setGenre(Genre genre) {
        this.genre = genre;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPublishingHouse() {
        return publishingHouse;
    }

    public void setPublishingHouse(String publishingHouse) {
        this.publishingHouse = publishingHouse;
    }

    public int getYearPublishing() {
        return yearPublishing;
    }

    public void setYearPublishing(int yearPublishing) {
        this.yearPublishing = yearPublishing;
    }

    public int getNumberOfPage() {
        return numberOfPage;
    }

    public void setNumberOfPage(int numberOfPage) {
        this.numberOfPage = numberOfPage;
    }

    public int getQuantity() {
        return quantity;
    }

    public void setQuantity(int quantity) {
        this.quantity = quantity;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Book book = (Book) o;
        return yearPublishing == book.yearPublishing && numberOfPage == book.numberOfPage && quantity == book.quantity && genre == book.genre && Objects.equals(author, book.author) && Objects.equals(name, book.name) && Objects.equals(publishingHouse, book.publishingHouse);
    }

    @Override
    public int hashCode() {
        return Objects.hash(genre, author, name, publishingHouse, yearPublishing, numberOfPage, quantity);
    }

    @Override
    public String toString() {
        return "Book{" + "genre=" + genre + ", author='" + author + '\'' + ", name='" + name + '\'' + ", publishingHouse='" + publishingHouse + '\'' + ", yearPublishing=" + yearPublishing + ", numberOfPage=" + numberOfPage + ", quantity=" + quantity + "} " + super.toString();
    }

    public static class BookBuilder {
        private Integer id;
        private Genre genre;
        private String author;
        private String name;
        private String publishingHouse;
        private int yearPublishing;
        private int numberOfPage;
        private int quantity;

        public BookBuilder withId(Integer id) {
            this.id = id;
            return this;
        }

        public BookBuilder withGenre(Genre genre) {
            this.genre = genre;
            return this;
        }

        public BookBuilder withAuthor(String author) {
            this.author = author;
            return this;
        }

        public BookBuilder withName(String name) {
            this.name = name;
            return this;
        }

        public BookBuilder withPublishingHouse(String publishingHouse) {
            this.publishingHouse = publishingHouse;
            return this;
        }

        public BookBuilder withYearPublishing(int yearPublishing) {
            this.yearPublishing = yearPublishing;
            return this;
        }

        public BookBuilder withNumberOfPage(int numberOfPage) {
            this.numberOfPage = numberOfPage;
            return this;
        }

        public BookBuilder withQuantity(int quantity) {
            this.quantity = quantity;
            return this;
        }

        public Book build() {
            Book book = new Book(this.id);
            book.setGenre(this.genre);
            book.setAuthor(this.author);
            book.setName(this.name);
            book.setPublishingHouse(this.publishingHouse);
            book.setYearPublishing(this.yearPublishing);
            book.setNumberOfPage(this.numberOfPage);
            book.setQuantity(this.quantity);
            return book;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            BookBuilder that = (BookBuilder) o;
            return yearPublishing == that.yearPublishing && numberOfPage == that.numberOfPage && quantity == that.quantity && Objects.equals(id, that.id) && genre == that.genre && Objects.equals(author, that.author) && Objects.equals(name, that.name) && Objects.equals(publishingHouse, that.publishingHouse);
        }

        @Override
        public int hashCode() {
            return Objects.hash(id, genre, author, name, publishingHouse, yearPublishing, numberOfPage, quantity);
        }

        @Override
        public String toString() {
            return "BookBuilder{" + "id=" + id + ", genre=" + genre + ", author='" + author + '\'' + ", name='" + name + '\'' + ", publishingHouse='" + publishingHouse + '\'' + ", yearPublishing=" + yearPublishing + ", numberOfPage=" + numberOfPage + ", quantity=" + quantity + '}';
        }
    }
}

src/main/java/com/epam/libraryProject/repository/entity/book/Genre.java
package com.epam.libraryProject.repository.entity.book;

import java.util.Arrays;

public enum Genre {
    DETECTIVE(1),
    FANTASTIC(2),
    ADVENTURE(3),
    NOVEL(4),
    SCIENTIFIC(5),
    CHILDREN(6),
    EDUCATIONAL(7);

    private final int genreId;

    Genre(int genreId) {
        this.genreId = genreId;
    }

    public int getGenreId() {
        return genreId;
    }

    public static Genre getGenreById(int genreId) {
        return Arrays.stream(Genre.values())
                .filter(genre -> genre.getGenreId() == genreId)
                .findFirst()
                .orElse(null);
    }
}

src/main/java/com/epam/libraryProject/repository/entity/genre/Genre.java
package com.epam.libraryProject.repository.entity.genre;

import com.epam.libraryProject.repository.entity.Entity;

import java.util.Objects;

public class Genre extends Entity<Integer> {
    private String name;

    public Genre() {
    }

    public Genre(Integer id) {
        super(id);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Genre genre = (Genre) o;
        return Objects.equals(name, genre.name);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name);
    }

    @Override
    public String toString() {
        return "Genre{" +
                "name='" + name + '\'' +
                '}';
    }

    public static class GenreBuilder {

        private Integer id;
        private String name;

        public GenreBuilder withId(Integer id) {
            this.id = id;
            return this;
        }

        public GenreBuilder withName(String name) {
            this.name = name;
            return this;
        }


        public Genre build() {
            Genre genre = new Genre(this.id);
            genre.setName(this.name);
            return genre;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            GenreBuilder that = (GenreBuilder) o;
            return Objects.equals(id, that.id) &&
                    Objects.equals(name, that.name);
        }

        @Override
        public int hashCode() {
            return Objects.hash(id, name);
        }

        @Override
        public String toString() {
            return "GenreBuilder{" +
                    "id=" + id +
                    ", name='" + name + '\'' +
                    '}';
        }
    }
}

src/main/java/com/epam/libraryProject/repository/entity/order/OrderStatus.java
package com.epam.libraryProject.repository.entity.order;

import java.util.Arrays;

public enum OrderStatus {
    WAITING(1),
    ACTIVE(2),
    CANCELED(3),
    COMPLETED(4);
    private final int statusId;

    OrderStatus(int statusId) {
        this.statusId = statusId;
    }

    public int getStatusId() {
        return statusId;
    }

    public static OrderStatus getStatusById(int statusId) {
        return Arrays.stream(OrderStatus.values())
                .filter(status -> status.getStatusId() == statusId)
                .findFirst()
                .orElse(null);
    }
}

src/main/java/com/epam/libraryProject/repository/entity/user/User.java
package com.epam.libraryProject.repository.entity.user;

import com.epam.libraryProject.repository.entity.Entity;

import java.util.Objects;

public class User extends Entity<Integer> {
    private String login;
    private String password;
    private UserRole role;

    public User() {
    }
    public User(Integer id, String login, String password, int roleId) {
        super(id);
        this.login = login;
        this.password = password;
        this.role = UserRole.getRoleById(roleId);
    }
    public User(String login, String password) {
        this.login = login;
        this.password = password;
    }


    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public UserRole getRole() {
        return role;
    }

    public void setRole(UserRole role) {
        this.role = role;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        User user = (User) o;
        return login.equals(user.login) && password.equals(user.password) && role == user.role;
    }

    @Override
    public int hashCode() {
        return Objects.hash(login, password, role);
    }

    @Override
    public String toString() {
        return "User{" + "login='" + login + '\'' + ", password='" + password + '\'' + ", role=" + role + "} " + super.toString();
    }
}

src/main/java/com/epam/libraryProject/repository/entity/user/UserRole.java
package com.epam.libraryProject.repository.entity.user;

import java.util.Arrays;
import java.util.List;

public enum UserRole {
    ADMIN(1),
    USER(2),
    GUEST(3);

    private final int id;
    private static final List<UserRole> ALL_AVAILABLE_ROLES = Arrays.asList(values());

    UserRole(int id) {
        this.id = id;
    }

    public int getRoleId() {
        return id;
    }

    public static UserRole getRoleById(int id) {
        return Arrays.stream(UserRole.values())
                .filter(role -> role.getRoleId() == id)
                .findFirst()
                .orElse(null);
    }

    public static List<UserRole> valuesAsList() {
        return ALL_AVAILABLE_ROLES;
    }
}

src/main/java/com/epam/libraryProject/service/dto/EntityDto.java
package com.epam.libraryProject.service.dto;

public class EntityDto<T> {
    private T id;

    public EntityDto() {
    }

    public EntityDto(T id) {
        this.id = id;
    }

    public T getId() {
        return id;
    }

    public void setId(T id) {
        this.id = id;
    }

    @Override
    public String toString() {
        return "EntityDto{" + "id=" + id + '}';
    }
}

src/main/java/com/epam/libraryProject/controller/ApplicationController.java
package com.epam.libraryProject.controller;

import com.epam.libraryProject.controller.command.api.Command;
import com.epam.libraryProject.controller.command.api.CommandRequest;
import com.epam.libraryProject.controller.command.api.CommandResponse;
import com.epam.libraryProject.repository.connection.api.ConnectionPool;
import com.epam.libraryProject.repository.connection.api.impl.ConnectionPoolImpl;
import com.epam.libraryProject.repository.exception.DaoException;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Optional;

@WebServlet(urlPatterns = "/controller")
public class ApplicationController extends HttpServlet {
    private static final Logger log = LogManager.getLogger(ApplicationController.class);

    private final ConnectionPool connectionPool = ConnectionPoolImpl.getInstance();

    public static final String COMMAND_PARAM = "command";
    private static final String INIT_ERROR_MESSAGE = "Can't initialize the connectionPool";
    private static final String DESTROY_ERROR_MESSAGE = "Can't shutdown the connectionPool";

    public ApplicationController() { super();}

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        process(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        process(req, resp);
    }

    private void process(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        final String commandName = req.getParameter(COMMAND_PARAM);
        final Command command = Command.withName(commandName);
        final CommandResponse response = command.execute(new CommandRequest() {
            private static final String REFERER = "referer";
            @Override
            public HttpSession createSession() {
                return req.getSession(true);
            }

            @Override
            public Optional<HttpSession> getCurrentSession() {
                return Optional.ofNullable(req.getSession(false));
            }

            @Override
            public void invalidateCurrentSession() {
                final HttpSession session = req.getSession(false);
                if (session != null) {
                    session.invalidate();
                }
            }

            @Override
            public String getParameter(String name) {
                return req.getParameter(name);
            }

            @Override
            public void setAttribute(String name, Object value) {
                req.setAttribute(name, value);
            }

            @Override
            public String getHeader() {
                return req.getHeader(REFERER);
            }

            @Override
            public String getContextPath() {
                return req.getContextPath();
            }
        });

        if (response.isRedirect()) {
            resp.sendRedirect(response.getPath());
        } else {
            RequestDispatcher dispatcher = req.getRequestDispatcher(response.getPath());
            dispatcher.forward(req, resp);
        }
    }


    @Override
    public void init() {
        try {
            connectionPool.init();
        } catch (DaoException e) {
            log.error(INIT_ERROR_MESSAGE, e);
        }
    }

    @Override
    public void destroy() {
        super.destroy();
        try {
            connectionPool.destroy();
        } catch (DaoException e) {
            log.error(DESTROY_ERROR_MESSAGE, e);
        }
    }
}

src/main/webapp/WEB-INF/jsp/addBook.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE html>
<html>
  <c:choose>
    <c:when test="${not empty language}">
      <fmt:setLocale value="${sessionScope.language}" />
    </c:when>
    <c:when test="${empty language}">
      <fmt:setLocale value="en" />
    </c:when>
  </c:choose>
  <fmt:setBundle basename="language" />
  <head>
    <title>
      <fmt:message key="sign_in_page.title" />
    </title>
    <c:import url="parts/header.jsp" />
  </head>
  <%@ include file="parts/navigation.jsp" %>
   <div class="small-breadcrumb">
    <div class="container">
      <div class=" breadcrumb-link">
        <ul>
          <li>&nbsp;</li>
        </ul>
      </div>
    </div>
  </div>
  <div class="main-content-area clearfix">
    <section class="section-padding error-page pattern-bg ">
      <!-- Main Container -->
      <div class="container">
           <h3>Add book</h3>
        <!-- Row -->
        <div class="row">
          <!-- Middle Content Area -->
          <div class="col-md-5 col-md-push-3 col-sm-6 col-xs-12">
            <!--  Form -->
            <div class="form-grid">
              <form id="login-form" class="form" action="final-project-epam" method="post">
                <div class="form-group">
                  <label for="name" class="text-light">
                    <fmt:message key="add_book.name_of_book" />
                  </label>
                  <br>
                  <input type="text" name="name" id="name" class="form-control" required />
                </div>
                <div class="form-group">
                  <label for="author" class="text-light">
                    <fmt:message key="add_book.author" />
                  </label>
                  <br>
                  <input type="text" name="author" id="author" class="form-control" required />
                </div>
                <div class="form-group">
                  <label for="publisher" class="text-light">
                    <fmt:message key="add_book.publishing_house" />
                  </label>
                  <br>
                  <input type="text" name="publisher" id="publisher" class="form-control" required />
                </div>
                <div class="form-group">
                  <span class="form-label">
                    <fmt:message key="add_book.genre" />
                  </span>
                  <select class="form-control" required name="genre">
                    <option value="" selected hidden>
                      <fmt:message key="add_book.select_genre" />
                    </option>
                    <option value="1">
                      <fmt:message key="add_book.detective" />
                    </option>
                    <option value="2">
                      <fmt:message key="add_book.fantastic" />
                    </option>
                    <option value="3">
                      <fmt:message key="add_book.adventure" />
                    </option>
                    <option value="4">
                      <fmt:message key="add_book.novel" />
                    </option>
                    <option value="5">
                      <fmt:message key="add_book.scientific" />
                    </option>
                    <option value="6">
                      <fmt:message key="add_book.children" />
                    </option>
                    <option value="7">
                      <fmt:message key="add_book.educational" />
                    </option>
                  </select>
                  <span class="select-arrow"></span>
                </div>
                <div class="form-group">
                  <label for="yearPublishing" class="text-light">
                    <fmt:message key="add_book.year_publishing" />
                  </label>
                  <br>
                  <input type="text" name="yearPublishing" id="yearPublishing" class="form-control" required />
                </div>
                <div class="form-group">
                  <label for="pages" class="text-light">
                    <fmt:message key="add_book.number_of_page" />
                  </label>
                  <br>
                  <input type="text" name="pages" id="pages" class="form-control" required "/>
                </div>
                <div class="form-group">
                  <label for="quantity" class="text-light">
                    <fmt:message key="add_book.quantity" />
                  </label>
                  <br>
                  <input type="text" name="quantity" id="quantity" class="form-control" required"/>
                </div>
                <div style="color: red;">
                  <p>
               <c:choose>
                         <c:when test="${not empty requestScope.error}">
                             <div class = "col-3">
                                 <div class="alert alert-danger alert-dismissible">
                                     <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                     ${error}
                                 </div>
                             </div>
                         </c:when>
                     </c:choose>
                     <c:choose>
                         <c:when test="${not empty requestScope.successAddBook}">
                             <p>${requestScope.error}</p>
                             <a href="${pageContext.request.contextPath}/controller?command=SHOW_ADD_BOOK_PAGE">Try again</a>
                         </c:when>
                         <c:otherwise>
                             <c:if test="${sessionScope.successAddBook == true}">
                               <div class = "col-3">
                                     <div class="alert alert-success alert-dismissible">
                                         <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                         <fmt:message key="alert.success_add_book"/>
                                     </div>
                                     <%session.setAttribute("successAddBook", false);%>
                                 </div>
                             </c:if>
                         </c:otherwise>
                     </c:choose>
                  </p>
                </div>
                <input type="hidden" name="command" value="ADD_BOOK" />
                <input type="submit" class="btn btn-theme btn-lg btn-block" value=<fmt:message key="add_book.add_button"/>
                                                                                                                >
              </form>
            </div>
            <!-- Form -->
          </div>
        </div>
        <!-- Row End -->
      </div>
      <!-- Main Container End -->
    </section>
    <c:import url="parts/footer.jsp" />
  </div>
  </body>
</html>

src/main/webapp/WEB-INF/jsp/allUsers.jsp
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE html>
<html>
  <c:choose>
    <c:when test="${not empty language}">
      <fmt:setLocale value="${sessionScope.language}" />
    </c:when>
    <c:when test="${empty language}">
      <fmt:setLocale value="en" />
    </c:when>
  </c:choose>
  <fmt:setBundle basename="language" />
  <head>
   <title><fmt:message key="users.title"/></title>
    <c:import url="parts/header.jsp" />
  </head>
  <%@ include file="parts/navigation.jsp" %> <div class="small-breadcrumb">
    <div class="container">
      <div class=" breadcrumb-link">
        <ul>
          <li>&nbsp;</li>
        </ul>
      </div>
    </div>
  </div>
  <div class="main-content-area clearfix">
    <section class="section-padding gray">
      <!-- Main Container -->
      <div class="container">
        <h3>
           <fmt:message key="users.title"/>
        </h3>
        <!-- Row -->
        <div class="row">
          <div class="col-md-12 col-sm-12 col-xs-12">
            <!-- Row -->
            <div class="row">
              <div class="col-md-12 col-xs-12 col-sm-12 col-lg-12 heading">
                         <table class="table table-striped">
                             <c:choose>
                                 <c:when test="${empty allUsers && allUsers.size() == 0}">
                                     <tr>
                                         <td><fmt:message key="catalog.not_found_message"/></td>
                                     </tr>
                                 </c:when>
                                 <c:when test="${not empty allUsers}">
                                     <tr>
                                         <th><fmt:message key="users.login"/></th>
                                         <th><fmt:message key="users.first_name"/></th>
                                         <th><fmt:message key="users.second_name"/></th>
                                         <th><fmt:message key="users.phone"/></th>
                                         <th><fmt:message key="users.subscription"/></th>
                                     </tr>
                                     <c:forEach items="${sessionScope.allUsers}" var="user">
                                         <tr>
                                             <td>${user.user.login}</td>
                                             <td>${user.firstName}</td>
                                             <td>${user.secondName}</td>
                                             <td>${user.phone}</td>
                                             <c:if test="${user.subscriptionId == null}">
                                                 <td>-</td>
                                             </c:if>
                                             <c:if test="${user.subscriptionId != null}">
                                                 <td>${user.subscriptionId}</td>
                                             </c:if>

                                         </tr>
                                     </c:forEach>
                                 </c:when>
                             </c:choose>
                         </table>
                  <c:if test="${empty allUsers && allUsers.size() == 0}"> No data </c:if>
                         <c:choose>
                              <c:when test="${not empty sessionScope.error}">
                                  <div class = "container p-3">
                                      <div class="alert alert-danger alert-dismissible" style="width: 500px; margin:auto">
                                          <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                          ${error}
                                      </div>
                                      <%session.setAttribute("error", "");%>
                                  </div>
                              </c:when>
                          </c:choose>
                          <c:choose>
                              <c:when test="${not empty requestScope.error}">
                                  <div class = "container p-3">
                                      <div class="alert alert-danger alert-dismissible" style="width: 500px; margin:auto">
                                          <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                          ${error}
                                      </div>
                                  </div>
                              </c:when>
                          </c:choose>
                          <c:choose>
                              <c:when test="${not empty requestScope.successMakeOrder}">
                                  <a href="${pageContext.request.contextPath}/controller?command=SHOW_ALL_BOOKS">Try again</a>
                              </c:when>
                              <c:otherwise>
                                  <c:if test="${sessionScope.successMakeOrder == true}">
                                      <div class = "container p-3">
                                          <div class="alert alert-success alert-dismissible" style="width: 500px; margin:auto">
                                              <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                              <fmt:message key="alert.success_make_order"/> "${sessionScope.orderNameBook}"!
                                          </div>
                                          <%session.setAttribute("successMakeOrder", false);%>
                                      </div>
                                  </c:if>
                              </c:otherwise>
                          </c:choose>
                          <c:choose>
                              <c:when test="${not empty requestScope.successEditBook}">
                                  <a href="${pageContext.request.contextPath}/controller?command=SHOW_ALL_BOOKS">Try again</a>
                              </c:when>
                              <c:otherwise>
                                  <c:if test="${sessionScope.successEditBook == true}">
                                      <div class = "container p-3">
                                          <div class="alert alert-success alert-dismissible" style="width: 500px; margin:auto">
                                              <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                              <fmt:message key="alert.success_edit_book"/>
                                          </div>
                                          <%session.setAttribute("successEditBook", false);%>
                                      </div>
                                  </c:if>
                              </c:otherwise>
                          </c:choose>
                </div>
              </div>
              <div class="clearfix"></div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <c:import url="parts/footer.jsp" />
  </div>
  </body>
</html>